//EASY UART֐ 
//2007.9.25
//MPLAB C30t PIC24FCugp:libpPIC24Fxxx-coff.a
//UART1 MRXF荞ݎgp MTXF|[Ogp

#define USE_AND_OR     //CuORgp(CũCN[ht@COɒu)

#include "p24FJ64GA002.h"
#include "stdio.h"
#include "uart.h"

#include "EasyUart.h"

/* Received data is stored in array Buf */
volatile char Buf[128];//i[̂́ApӂoCg1oCgȂ(wcntBufrcntBufƂ̓f[^Ӗ邽)
volatile int wcntBuf=0;//CgJEg
volatile int rcntBuf=0;//[hJEg

/* This is UART1 receive ISR */
void __attribute__((__interrupt__, ,no_auto_psv)) _U1RXInterrupt(void)
{
    int len;
    IFS0bits.U1RXIF = 0;

    len = wcntBuf - rcntBuf;
    if(len<0) len = len + sizeof(Buf);

    if(len<sizeof(Buf)-1){
        Buf[wcntBuf] = ReadUART1();
        if(wcntBuf<sizeof(Buf)-1) wcntBuf++;
        else wcntBuf=0;
    }
    else ReadUART1();//ǂݎ̂
}

//UART1
void Uart1Init(unsigned long fcy, unsigned int baudrate)
{
    unsigned int baudvalue;
    unsigned int U1MODEvalue;
    unsigned int U1STAvalue;

    wcntBuf=0;
    rcntBuf=0;

    CloseUART1();
    ConfigIntUART1(UART_RX_INT_EN | UART_RX_INT_PR4);//Enable RX荞, RXvCIeB[4

    baudvalue = fcy/16/baudrate - 1;//bps

    U1MODEvalue = UART_EN;//Enable Uart, Data 8bit, No Parity,
                          //1 stop bit, FlowȂ,LOOP BACKȂ,WAKEUPȂ,ABAUDȂ
                          //RX IDLE=1, ᑬ{[[g

    U1STAvalue = UART_TX_ENABLE | UART_RX_OVERRUN_CLEAR /*| UART_IrDA_POL_INV_ZERO | UART_SYNC_BREAK_DISABLED */ ;//Enable TX, 1charɎM荞, 

    OpenUART1(U1MODEvalue, U1STAvalue, baudvalue);
}

//Oobt@֏񂾃f[^M̂҂
void Uart1PutEndWait()
{
    while(BusyUART1());//M҂
}

//Oobt@֏(P)
void Uart1PutChar(char dat)
{
    while(U1STAbits.UTXBF);//FIFO󂫑҂
    WriteUART1(dat);
}

//Oobt@֏(f[^)
void Uart1PutData(char *dat, int szbyte)
{
    while(szbyte--){
        while(U1STAbits.UTXBF);//FIFO󂫑҂
        WriteUART1(*dat++);
    }
}

//Oobt@֏()
void Uart1PutStr(char *dat)
{
    while(*dat!=0){
        while(U1STAbits.UTXBF);//FIFO󂫑҂
        WriteUART1(*dat++);
    }
}

//Oobt@ǂݍ
int Uart1GetChar()
{
    int c;

    c = Buf[rcntBuf];

    if(rcntBuf!=wcntBuf){
        if(rcntBuf<sizeof(Buf)-1) rcntBuf++;
        else rcntBuf=0;
    }
    else{
        c = -1;//ǂݍ݂̃f[^͖
    }

    return (c);
}

//Oobt@̖ǂݍ݂̃oCg𓾂
int Uart1GetCnt()
{
    int len;
    len = wcntBuf - rcntBuf;

    if(len<0) len = len + sizeof(Buf);

    return(len);
}
